/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GuarddutyMalwareProtectionPlanConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#actions GuarddutyMalwareProtectionPlan#actions}
    */
    readonly actions?: GuarddutyMalwareProtectionPlanActions[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#role GuarddutyMalwareProtectionPlan#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#tags GuarddutyMalwareProtectionPlan#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * protected_resource block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#protected_resource GuarddutyMalwareProtectionPlan#protected_resource}
    */
    readonly protectedResource?: GuarddutyMalwareProtectionPlanProtectedResource[] | cdktf.IResolvable;
}
export interface GuarddutyMalwareProtectionPlanActionsTagging {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#status GuarddutyMalwareProtectionPlan#status}
    */
    readonly status?: string;
}
export declare function guarddutyMalwareProtectionPlanActionsTaggingToTerraform(struct?: GuarddutyMalwareProtectionPlanActionsTagging | cdktf.IResolvable): any;
export declare function guarddutyMalwareProtectionPlanActionsTaggingToHclTerraform(struct?: GuarddutyMalwareProtectionPlanActionsTagging | cdktf.IResolvable): any;
export declare class GuarddutyMalwareProtectionPlanActionsTaggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GuarddutyMalwareProtectionPlanActionsTagging | cdktf.IResolvable | undefined;
    set internalValue(value: GuarddutyMalwareProtectionPlanActionsTagging | cdktf.IResolvable | undefined);
    private _status?;
    get status(): string;
    set status(value: string);
    resetStatus(): void;
    get statusInput(): string | undefined;
}
export declare class GuarddutyMalwareProtectionPlanActionsTaggingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GuarddutyMalwareProtectionPlanActionsTagging[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GuarddutyMalwareProtectionPlanActionsTaggingOutputReference;
}
export interface GuarddutyMalwareProtectionPlanActions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#tagging GuarddutyMalwareProtectionPlan#tagging}
    */
    readonly tagging?: GuarddutyMalwareProtectionPlanActionsTagging[] | cdktf.IResolvable;
}
export declare function guarddutyMalwareProtectionPlanActionsToTerraform(struct?: GuarddutyMalwareProtectionPlanActions | cdktf.IResolvable): any;
export declare function guarddutyMalwareProtectionPlanActionsToHclTerraform(struct?: GuarddutyMalwareProtectionPlanActions | cdktf.IResolvable): any;
export declare class GuarddutyMalwareProtectionPlanActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GuarddutyMalwareProtectionPlanActions | cdktf.IResolvable | undefined;
    set internalValue(value: GuarddutyMalwareProtectionPlanActions | cdktf.IResolvable | undefined);
    private _tagging;
    get tagging(): GuarddutyMalwareProtectionPlanActionsTaggingList;
    putTagging(value: GuarddutyMalwareProtectionPlanActionsTagging[] | cdktf.IResolvable): void;
    resetTagging(): void;
    get taggingInput(): cdktf.IResolvable | GuarddutyMalwareProtectionPlanActionsTagging[] | undefined;
}
export declare class GuarddutyMalwareProtectionPlanActionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GuarddutyMalwareProtectionPlanActions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GuarddutyMalwareProtectionPlanActionsOutputReference;
}
export interface GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#bucket_name GuarddutyMalwareProtectionPlan#bucket_name}
    */
    readonly bucketName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#object_prefixes GuarddutyMalwareProtectionPlan#object_prefixes}
    */
    readonly objectPrefixes?: string[];
}
export declare function guarddutyMalwareProtectionPlanProtectedResourceS3BucketToTerraform(struct?: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket | cdktf.IResolvable): any;
export declare function guarddutyMalwareProtectionPlanProtectedResourceS3BucketToHclTerraform(struct?: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket | cdktf.IResolvable): any;
export declare class GuarddutyMalwareProtectionPlanProtectedResourceS3BucketOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket | cdktf.IResolvable | undefined;
    set internalValue(value: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket | cdktf.IResolvable | undefined);
    private _bucketName?;
    get bucketName(): string;
    set bucketName(value: string);
    get bucketNameInput(): string | undefined;
    private _objectPrefixes?;
    get objectPrefixes(): string[];
    set objectPrefixes(value: string[]);
    resetObjectPrefixes(): void;
    get objectPrefixesInput(): string[] | undefined;
}
export declare class GuarddutyMalwareProtectionPlanProtectedResourceS3BucketList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GuarddutyMalwareProtectionPlanProtectedResourceS3BucketOutputReference;
}
export interface GuarddutyMalwareProtectionPlanProtectedResource {
    /**
    * s3_bucket block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#s3_bucket GuarddutyMalwareProtectionPlan#s3_bucket}
    */
    readonly s3Bucket?: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket[] | cdktf.IResolvable;
}
export declare function guarddutyMalwareProtectionPlanProtectedResourceToTerraform(struct?: GuarddutyMalwareProtectionPlanProtectedResource | cdktf.IResolvable): any;
export declare function guarddutyMalwareProtectionPlanProtectedResourceToHclTerraform(struct?: GuarddutyMalwareProtectionPlanProtectedResource | cdktf.IResolvable): any;
export declare class GuarddutyMalwareProtectionPlanProtectedResourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): GuarddutyMalwareProtectionPlanProtectedResource | cdktf.IResolvable | undefined;
    set internalValue(value: GuarddutyMalwareProtectionPlanProtectedResource | cdktf.IResolvable | undefined);
    private _s3Bucket;
    get s3Bucket(): GuarddutyMalwareProtectionPlanProtectedResourceS3BucketList;
    putS3Bucket(value: GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket[] | cdktf.IResolvable): void;
    resetS3Bucket(): void;
    get s3BucketInput(): cdktf.IResolvable | GuarddutyMalwareProtectionPlanProtectedResourceS3Bucket[] | undefined;
}
export declare class GuarddutyMalwareProtectionPlanProtectedResourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: GuarddutyMalwareProtectionPlanProtectedResource[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): GuarddutyMalwareProtectionPlanProtectedResourceOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan aws_guardduty_malware_protection_plan}
*/
export declare class GuarddutyMalwareProtectionPlan extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_guardduty_malware_protection_plan";
    /**
    * Generates CDKTF code for importing a GuarddutyMalwareProtectionPlan resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GuarddutyMalwareProtectionPlan to import
    * @param importFromId The id of the existing GuarddutyMalwareProtectionPlan that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GuarddutyMalwareProtectionPlan to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/5.75.0/docs/resources/guardduty_malware_protection_plan aws_guardduty_malware_protection_plan} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GuarddutyMalwareProtectionPlanConfig
    */
    constructor(scope: Construct, id: string, config: GuarddutyMalwareProtectionPlanConfig);
    private _actions;
    get actions(): GuarddutyMalwareProtectionPlanActionsList;
    putActions(value: GuarddutyMalwareProtectionPlanActions[] | cdktf.IResolvable): void;
    resetActions(): void;
    get actionsInput(): cdktf.IResolvable | GuarddutyMalwareProtectionPlanActions[] | undefined;
    get arn(): string;
    get createdAt(): string;
    get id(): string;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    get status(): string;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll;
    get tagsAll(): cdktf.StringMap;
    private _protectedResource;
    get protectedResource(): GuarddutyMalwareProtectionPlanProtectedResourceList;
    putProtectedResource(value: GuarddutyMalwareProtectionPlanProtectedResource[] | cdktf.IResolvable): void;
    resetProtectedResource(): void;
    get protectedResourceInput(): cdktf.IResolvable | GuarddutyMalwareProtectionPlanProtectedResource[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
